local E, L, V, P, G = unpack(ElvUI);
local mPlugin = "mMediaTag"
local mMT = E:NewModule(mPlugin, "AceHook-3.0", "AceEvent-3.0", "AceTimer-3.0");
local EP = LibStub("LibElvUIPlugin-1.0")
local addon, ns = ...
local Version = GetAddOnMetadata(addon, "Version")

local _G = _G
local ReloadUI = ReloadUI

P[mPlugin] = {
	["mMsg"] 				= true,
	["mTIcon"] 				= true,
	["mTIconSize"] 			= 32,
	["mProfUp"] 			= false,
	["mProfIcon"] 			= true,
	["mMenuUp"] 			= false,
	["mMenuColor"] 			= true,
	["mClassColorHover"] 	= true,
	["mHoverTexture"] 		= "|CFF8E44ADm|r|CFF2ECC71Media|r |CFF3498DB4a|r",
	["mPluginVersion"] 		= 0,
}

ns.mName 	= "|CFF8E44ADm|r|CFF2ECC71Media|r|CFF3498DBTag|r"
ns.mVersion = Version
ns.mColor1 	= "|CFFFFFFFF"	-- white
ns.mColor2 	= "|CFFF7DC6F" 	-- yellow
ns.mColor3 	= "|CFF8E44AD"	-- purple
ns.mColor4 	= "|CFFFE7B2C" 	-- orange
ns.mColor5 	= "|CFFE74C3C" 	-- red
ns.mColor6 	= "|CFF58D68D" 	-- green
ns.mColor7 	= "|CFF3498DB" 	-- blue
ns.mColor8 	= "|CFFB2BABB" 	-- gray

local function mChangeLog()
	local cTitle, cText1, cText2, cText3, cText4, cText5, cDate = ""
	local cLine1 = "|n"
	local cLine2 = "|n|n"
	local cLine3 = "|n|n|n"
	
	cDate  = "29.04.2020"
	cTitle = "|CFF8E44ADm|r|CFF2ECC71Media|r|CFF3498DBTag|r Changelog!"
	cText1 = L["Attention! Important! changes in this version!"] 
	cText2 = L["Attention Status bar texture names have changed!"]
	cText3 = L["New textures, attention texture names have changed."]
	cText4 = L["New Tags, mClass:short, mGroup, mGroup:short, mPvP:left, mPvP:right, mPvP:icon."]
	cText5 = L["Hover texture and Kalasssen color menu."]
	
	cTitle = format("%s - %s", cTitle, cDate)
	cText1 = format("%s%s|r", ns.mColor5, cText1)
	cText2 = format("%s%s|r", ns.mColor5, cText2)
	cText3 = format("%s%s|r", ns.mColor2, cText3)
	cText4 = format("%s%s|r", ns.mColor2, cText4)
	cText5 = format("%s%s|r", ns.mColor2, cText5)
	
	return format("%s%s%s%s%s%s%s%s%s%s%s%s", cTitle, cLine3, cText1, cLine2, cText2, cLine2, cText3, cLine1, cText4, cLine1, cText5, cLine1)
	
end

function mMT:Update()
	-- local enabled = E.db.mMT.SomeToggleOption
	-- local range = E.db.mMT.SomeRangeOption
	
	-- if enabled then
	-- print(range)
	-- else
	-- print("SomeToggleOption is disabled")
	-- end
end

function mMT:StartTimer(mTime)
  self:ScheduleTimer("TimerFeedback", mTime)
end

function mMT:TimerFeedback()
  print("5 seconds passed")
end

function mMT:InsertOptions()
	E.Options.args.mPlugin = {
		order = 100,
		type = "group",
		name = ns.mName,
		args = {
			header1 = {
				order = 1,
				type = "header",
				name = ns.mName,
			},
			logo = {
				order = 2,
				type = 'description',
				name = "",
				fontSize = 'medium',
				image = function() return 'Interface\\AddOns\\ElvUI_mMediaTag\\media\\textures\\logo.tga', 320, 80 end,
			},
			header2 = {
				order = 3,
				type = "header",
				name = "|CFF8E44ADby|r |CFF2ECC71Blin|r|CFF3498DBkii|r",
			},
			description1 = {
				order = 4,
				type = "description",
				name = ns.mName .. L[" is an addon for ElvUI with additional Statusbar textures, Tags, a game menu and professional menu for the datatext bars."],
			},
			spacer1 = {
				order = 5,
				type = "description",
				name = "\n\n\n",
			},
			header3 = {
				order = 6,
				type = "header",
				name = L["Configuration"],
			},
			setting1 = {
				order = 7,
				type = "group",
				name = L["General"],
				args = {
					mTGeneral = {
						order = 1,
						type = 'toggle',
						name = L["Greeting text at start"],
						desc = L["Enables or disables the welcome text, at startup."],
						get = function(info)
							return E.db[mPlugin].mMsg
						end,
						set = function(info, value)
							E.db[mPlugin].mMsg = value
						end,
					},
					mTColor = {
						order = 2,
						type = 'toggle',
						name = L["Class colered hover texture"],
						desc = L["Enables or disables Class colered hover texture."],
						get = function(info)
							return E.db[mPlugin].mClassColorHover
						end,
						set = function(info, value)
							E.db[mPlugin].mClassColorHover = value
							E:StaticPopup_Show("CONFIG_RL")
						end,
					},
					mTexture = {
						order = 3,
						type = "select",
						dialogControl = 'LSM30_Statusbar',
						name = L["Menu Hover Texture"],
						values = _G.AceGUIWidgetLSMlists.statusbar,
						get = function(info)
							return E.db[mPlugin].mHoverTexture
						end,
						set = function(info, value)
							E.db[mPlugin].mHoverTexture = value;
							E:StaticPopup_Show("CONFIG_RL")
						end,
					},
				},
			},
			setting2 = {
				order = 7,
				type = "group",
				name = L["Tooltip"],
				args = {
					mTIcon = {
						order = 2,
						type = 'toggle',
						name = L["Tooltip Icon"],
						desc = L["Enables or disables Tooltip Icon"],
						get = function(info)
							return E.db[mPlugin].mTIcon
						end,
						set = function(info, value)
							E.db[mPlugin].mTIcon = value
						end,
					
					},
					mRIcon = {
							order = 3,
							name = L["Iconsize"],
							desc = L["Tooltip Icon size."],
							type = "range",
							min = 16, max = 128, step = 2,
							get = function(info)
							return E.db[mPlugin].mTIconSize
							end,
							set = function(info, value)
								E.db[mPlugin].mTIconSize = value
							end,
					},
				},
			},
			setting3 = {
				order = 8,
				type = "group",
				name = L["Profession Menu"],
				args = {
					mTProfession1 = {
						order = 1,
						type = 'toggle',
						name = L["Fold up"],
						desc = L["When activated, the Profession Menu opens upwards."],
						get = function(info)
							return E.db[mPlugin].mProfUp
						end,
						set = function(info, value)
							E.db[mPlugin].mProfUp = value
						end,
					},
					mTProfession2 = {
						order = 2,
						type = 'toggle',
						name = L["Symbols"],
						desc = L["Displays the icons for the professions in the menu."],
						get = function(info)
							return E.db[mPlugin].mProfIcon
						end,
						set = function(info, value)
							E.db[mPlugin].mProfIcon = value
						end,
					},
				},
			},
			setting4 = {
				order = 9,
				type = "group",
				name = L['System Menu'],
				args = {
					mTMenu1 = {
						order = 1,
						type = 'toggle',
						name = L["Fold up"],
						desc = L["When activated, the System Menu opens upwards."],
						get = function(info)
							return E.db[mPlugin].mMenuUp
						end,
						set = function(info, value)
							E.db[mPlugin].mMenuUp = value
						end,
					},
					mTMenu2 = {
						order = 2,
						type = 'toggle',
						name = L["Colored System Menu"],
						desc = L["Activates a colored system menu."],
						get = function(info)
							return E.db[mPlugin].mMenuColor
						end,
						set = function(info, value)
							E.db[mPlugin].mMenuColor = value
						end,
					},
				},
			},
			-- setting5 = {
				-- order = 10,
				-- type = "group",
				-- name = L['Addons'],
				-- args = {
					-- install = {
						-- order = 7,
						-- type = "execute",
						-- name = "Install",
						-- desc = "Run the installation process.",
						-- func = function() mMT:SetupAddons() end,
					-- },
				-- },
			-- },
		},
	}
end

function mMT:Initialize()
	if E.db[mPlugin].mMsg then
		print (format(L["Welcome to %s version |CFF8E44AD%q|r, für |CFFFE7B2CElvUI|r!"],ns.mName, Version))
	end
	
	if E.db[mPlugin].mPluginVersion ~= Version then
		StaticPopupDialogs["mChangeLog"] = {
		  text = mChangeLog(),
		  button1 = "OK",
		  OnAccept = function()
			  E.db[mPlugin].mPluginVersion = Version
		  end,
		  timeout = 120,
		  whileDead = true,
		  hideOnEscape = true,
		  preferredIndex = 3,
		  }
		  
		  StaticPopup_Show ("mChangeLog")
	end
	
	EP:RegisterPlugin(addon, mMT.InsertOptions)
end

E:RegisterModule(mMT:GetName())