local E, L, V, P, G = unpack(ElvUI);
local mPlugin = "mMediaTag"
local mMT = E:GetModule(mPlugin);
local DT = E:GetModule("DataTexts");
local addon, ns = ...
local displayString = ""
local mText = L["Game Menu"]
local menuList = {}
local EasyMenu = EasyMenu
local menuFrame = CreateFrame("Frame", "mSystemMenu", E.UIParent)
	  menuFrame:SetTemplate("Transparent", true)

local function mColor(color)
	local mSetting = E.db[mPlugin].mMenuColor 
	if mSetting then
		if color == 1 then
			return ns.mColor1
		elseif color == 2 then
			return ns.mColor2
		elseif color == 3 then
			return ns.mColor3
		elseif color == 4 then
			return ns.mColor4
		elseif color == 5 then
			return ns.mColor5
		elseif color == 6 then
			return ns.mColor6
		elseif color == 7 then
			return ns.mColor7
		end
	else
		return ns.mColor1
	end
end

local function Update(self, t)

end

local function OnEvent(self, event, ...)
	self.text:SetFormattedText(displayString, mText)
end

local function Click()
	menuList = {}
	menuList = {
		{text = CHARACTER_BUTTON, isTitle = false, color = mColor(2),
		func = function() ToggleCharacter("PaperDollFrame") end},
		{text = SPELLBOOK_ABILITIES_BUTTON, isTitle = false, color = mColor(2),
		func = function() if not SpellBookFrame:IsShown() then ShowUIPanel(SpellBookFrame) else HideUIPanel(SpellBookFrame) end end},
		{text = TALENTS_BUTTON, isTitle = false,  color = mColor(2),
		func = function()
			if not PlayerTalentFrame then
				TalentFrame_LoadUI()
			end

			if not PlayerTalentFrame:IsShown() then
				ShowUIPanel(PlayerTalentFrame)
			else
				HideUIPanel(PlayerTalentFrame)
			end
		end},
		{text = ACHIEVEMENT_BUTTON, isTitle = false, color = mColor(2),
		func = function() ToggleAchievementFrame() end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = GARRISON_LANDING_PAGE_TITLE, isTitle = false, color = mColor(7),
		func = function() GarrisonLandingPageMinimapButton_OnClick() end},
		{text = COLLECTIONS, isTitle = false, color = mColor(7),
		func = function()
			ToggleCollectionsJournal()
		end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = TIMEMANAGER_TITLE, isTitle = false, color = mColor(1),
		func = function() ToggleFrame(TimeManagerFrame) end},
		{text = L["Calendar"], isTitle = false, color = mColor(1),
		func = function() GameTimeFrame:Click() end},

		{text = "", isTitle = true, func = function() end},
		
		{text = SOCIAL_BUTTON, isTitle = false, color = mColor(6),
		func = function() ToggleFriendsFrame() end},
		{text = ACHIEVEMENTS_GUILD_TAB, isTitle = false, color = mColor(6),
		func = function() ToggleGuildFrame() end},
		
		{text = "", isTitle = true,  func = function() end},
		
		{text = LFG_TITLE, isTitle = false, color = mColor(7),
		func = function() ToggleLFDParentFrame(); end},
		{text = ENCOUNTER_JOURNAL, isTitle = false, color = mColor(7),
		func = function() if not IsAddOnLoaded("Blizzard_EncounterJournal") then EncounterJournal_LoadUI(); end ToggleFrame(EncounterJournal) end},
		
		{text = "", isTitle = true, func = function() end},
		
		
		{text = "ElvUI", isTitle = false, color = mColor(4),
		func = function() 
			if InCombatLockdown() then _G.UIErrorsFrame:AddMessage(E.InfoColor.._G.ERR_NOT_IN_COMBAT) return end
			E:ToggleOptionsUI()
		end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = MAINMENU_BUTTON, isTitle = false, color = mColor(1),
		func = function()
			if ( not GameMenuFrame:IsShown() ) then
				if ( VideoOptionsFrame:IsShown() ) then
					VideoOptionsFrameCancel:Click();
				elseif ( AudioOptionsFrame:IsShown() ) then
					AudioOptionsFrameCancel:Click();
				elseif ( InterfaceOptionsFrame:IsShown() ) then
					InterfaceOptionsFrameCancel:Click();
				end
				CloseMenus();
				CloseAllWindows()
				ShowUIPanel(GameMenuFrame);
			else
				HideUIPanel(GameMenuFrame);
				MainMenuMicroButton_SetNormal();
			end
		end},
		
		{text = "", isTitle = true, func = function() end},
		
		{text = BLIZZARD_STORE, isTitle = false,  color = mColor(5), func = function() StoreMicroButton:Click() end},
		{text = HELP_BUTTON, isTitle = false,  color = mColor(5), func = function() ToggleHelpFrame() end}
	}
	mDropDown(menuList, menuFrame, E.db[mPlugin].mMenuUp, 160)
end

local function OnEnter(self)
	DT:SetupTooltip(self)
	DT.tooltip:AddLine(mText)
	DT.tooltip:AddLine("   ")
	DT.tooltip:AddLine(ns.mName .. " - Ver. " .. ns.mVersion)
	DT.tooltip:Show()
end

local function OnLeave(self)
	DT.tooltip:Hide()
end

local function ValueColorUpdate(hex)
	displayString = strjoin("", hex, "%s|r")

	if lastPanel ~= nil then
		OnEvent(lastPanel, "ELVUI_COLOR_UPDATE")
	end
end
E.valueColorUpdateFuncs[ValueColorUpdate] = true

DT:RegisterDatatext("Game Menu", {"PLAYER_ENTERING_WORLD"}, OnEvent, Update, Click, OnEnter, OnLeave, mText)